#include "internal.h"

pthread_mutex_t _U_dyn_info_list_lock = PTHREAD_MUTEX_INITIALIZER;

void
_U_dyn_register (unw_dyn_info_t *di)
{
  mutex_lock (&_U_dyn_info_list_lock);
  {
    ++_U_dyn_info_list.generation;

    di->next = _U_dyn_info_list.first;
    di->prev = NULL;
    if (di->next)
	    di->next->prev = di;
    _U_dyn_info_list.first = di;
  }
  mutex_unlock (&_U_dyn_info_list_lock);
}

pthread_mutex_t _U_dyn_info_remote_list_lock = PTHREAD_MUTEX_INITIALIZER;

#include <errno.h>
#include <sys/ptrace.h>

void
_U_dyn_register_remote (unw_word_t di, unw_word_t udil, pid_t pid)
{
  unw_dyn_info_list_t dummy_dil;
  unw_word_t generationOffset = ((unw_word_t)(& dummy_dil.generation)) - ((unw_word_t)(& dummy_dil));
  unw_word_t firstOffset = ((unw_word_t)(& dummy_dil.first)) - ((unw_word_t)(& dummy_dil));
  
  unw_dyn_info_t dummy_di;
  unw_word_t nextOffset = ((unw_word_t)(& dummy_di.next)) - ((unw_word_t)(& dummy_di));
  unw_word_t prevOffset = ((unw_word_t)(& dummy_di.prev)) - ((unw_word_t)(& dummy_di));
  
  errno = 0;
  
  mutex_lock(&_U_dyn_info_remote_list_lock);
  {
  	unw_word_t generation, first;
  	
	generation = ptrace( PTRACE_PEEKTEXT, pid, (void *)(udil + generationOffset), NULL );
    assert( errno == 0 );
    
    ++generation;
    
    ptrace( PTRACE_POKETEXT, pid, (void *)(udil + generationOffset), (void *)generation );
    assert( errno == 0 );
    
    
    first = ptrace( PTRACE_PEEKTEXT, pid, (void *)(udil + firstOffset), (void *)NULL );
    assert( errno == 0 );
    
    ptrace( PTRACE_POKETEXT, pid, (void *)(di + nextOffset), first );
    assert( errno == 0 );
    ptrace( PTRACE_POKETEXT, pid, (void *)(di + prevOffset), NULL );
    assert( errno == 0 );
    
    if ( first )
      {
      ptrace( PTRACE_POKETEXT, pid, (void *)(first + prevOffset), (void *)di );
      assert( errno == 0 );
      }
    
    ptrace( PTRACE_POKETEXT, pid, (void *)(udil + firstOffset), (void *)di );
    assert( errno == 0 );  
  }
  mutex_unlock(&_U_dyn_info_remote_list_lock);
}
